import graph;

void rectangle(real x, real largeur, real hauteur)
{
  pair p=(x,0), q=(x+largeur,hauteur);
  guide g=box(p,q);
  fill(g,lightgray); 
  draw(g); 
}

pen thin=linewidth(0.5*linewidth());
pen gras=linewidth(2*linewidth());

real f(real x) {return 1/(x+1);}
pair F(real x) {return (x,f(x));}

real a=0, nb=10, b=1;

real pas=(b-a)/10; 
for(int i=0; i <= (nb-1); ++i) {
	real x=a+i*pas;
	real xx=a+i*pas;
	rectangle(x,pas,f(xx));
}

// draw thin horizontal lines
for(int i=0; i < 21; ++i) {
  draw((-0.05,i*0.05)--(1,i*0.05), p=thin+dashed);
}
// draw thin vertical lines
for(int i=0; i < 20; ++i) {
  draw((i*0.05,-0.05)--(i*0.05,1), p=thin+dashed);
}


draw(graph(f,0,1),gras+blue);

xaxis(axis=YZero, xmin=-infinity, xmax=infinity, p=gras, LeftTicks, arrow=EndArrow(5), put=Below);
yaxis(axis=XZero, ymin=-infinity, ymax=infinity, p=gras, LeftTicks, arrow=EndArrow(5), put=Below);



shipout(currentpicture.fit(scale(10cm))); 


